<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Jrgen Unfried (juergen.unfried@beko.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Adressbook xhtml' for the 'beko_spdirectoryxhmlbugfix' extension.
 *
 * @author	Juergen Unfried <juergen.unfried@beko.at>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class ux_tx_spdirectory_pi1 extends tx_spdirectory_pi1 {
	/**
	 * This function generates the Jump Menu Code for zip and category
	 * (or basically for everything you specify in param)
	 *
	 *
	 * @param	int		The text for the dropdown field (key for the LL file!)
	 * @param	string	The entries for the dropdown box
	 * @return	string	The Javascript Dropdown Box code
	 * @usage	private
	 *
	 * Code adapted for xhml validity by Juergen Unfried 21.12.2005
	 */
	function getJumpMenuCode($param,$entries) {
		return "<script language=\"JavaScript\" type=\"text/JavaScript\">
		<!--
		function MM_jumpMenu(targ,selObj,restore){
  		eval(targ+\".location='\"+selObj.options[selObj.selectedIndex].value+\"'\");
  		if (restore) selObj.selectedIndex=0;
		}
		//-->
		</script>
		<form name=\"form1\" action=\"\">
		<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
  		<tr>
   		<td><select name=\"menu1\" onChange=\"MM_jumpMenu('self',this,0)\" class=\"tx_spdirectory-pi1-small\">
		<option value=\"".$this->pi_linkTP_keepPIvars_url("",1)."\">".$this->pi_getLL($param)."</option>".$entries."
  		</select></td>
  		</tr></table>
		</form>";
	} // end getJumpMenuCode

	/**
	 * Returns the Dropdown Box for Category
	 * Overwritten by Juergen Unfried 21.12.2005 - use a function to reduce code
	 */
	function makeJumper($modifier,$value)	{
		$pidlist = $this->pi_getPidlist($this->conf["pidList"],$this->conf["recursive"]);

		$query = "SELECT DISTINCT tx_spdirectory_cat.catname AS name, tx_spdirectory_cat_mm.uid_foreign AS id FROM tt_address, tx_spdirectory_cat, tx_spdirectory_cat_mm WHERE tt_address.pid IN (".$pidlist.")".$this->cObj->enableFields(tt_address)." AND tx_spdirectory_cat_mm.uid_local = tt_address.uid AND tx_spdirectory_cat.uid = tx_spdirectory_cat_mm.uid_foreign";
		$res = mysql(TYPO3_db,$query);

		while($tempo = mysql_fetch_assoc($res))	{
			$entries .= '<option value="'.$this->makeLink("",liste,cat,$tempo[id],$cache=1,$pointer=0).'"';
			$entries .= ($tempo[id]==$value&&$modifier==cat) ? ' selected="selected" style="color: '.$this->conf[active].';"' : "";
			$entries .= '>'.$tempo[name].'</option>';
		}
		return $this->getJumpMenuCode("category", $entries);
	}

	/**
	 * Returns the Dropdown Box for Category
	 * Overwritten by Juergen Unfried 21.12.2005 - use a function to reduce code
	 */
	function makeZIP($modifier,$value)	{
		$pidlist = $this->pi_getPidlist($this->conf["pidList"],$this->conf["recursive"]);

		$query = "SELECT DISTINCT zip FROM tt_address WHERE tt_address.pid IN (".$pidlist.")"." ".$this->cObj->enableFields(tt_address)." ORDER BY zip";
		$res = mysql(TYPO3_db,$query);

		while($tempo = mysql_fetch_assoc($res))	{
			$entries .= '<option value="'.$this->makeLink("",liste,zip,$tempo[zip],$cache=1,$pointer=0).'"';
			$entries .= ($tempo[zip]==$value&&$modifier==zip) ? ' selected="selected" style="color: '.$this->conf[active].'"' : "";
			$entries .= '>'.$tempo[zip].'</option>';
		}
		return $this->getJumpMenuCode("zip", $entries);
	}

	/**
	 * Generates a Dropdown Box
	 * Code adapted for xhml validity by Juergen Unfried 21.12.2005
	 */
	function makeDropDownList($id,$pid,$zip) {
		$pidList = $this->pi_getPidList($this->conf["pidList"],$this->conf["recursive"]);
		if ($this->conf["displayDropDownAll"]) {
			$query = "SELECT name,uid FROM tt_address WHERE pid IN (".$pidList.")"." ".$this->cObj->enableFields(tt_address)." ORDER BY NAME";
		} else {
			$pidList = ($this->cObj->data["tx_spdirectory_dspfolder"]) ? $pid : $pidList;
			switch($this->cObj->data["tx_spdirectory_mode"])        {
				case "0":
					$query = "SELECT name,uid FROM tt_address WHERE pid IN (".$pidList.")"." ".$this->cObj->enableFields(tt_address)." ORDER BY NAME";
				break;
                        	case "1":
					$q = "SELECT uid_foreign FROM tx_spdirectory_cat_mm WHERE uid_local='".$id."'";
                                        $r = $res = mysql(TYPO3_db,$q);
                                        while ($ro = mysql_fetch_assoc($r)) {
                                                $cat[] = $ro[uid_foreign];
                                        }
                                        $catList = implode(',', $cat);
					$query = "SELECT DISTINCT tt_address.name,tt_address.uid FROM tt_address,tx_spdirectory_cat_mm WHERE tt_address.uid=tx_spdirectory_cat_mm.uid_local AND tx_spdirectory_cat_mm.uid_foreign IN (".$catList.") AND tt_address.pid IN (".$pidList.")"." ".$this->cObj->enableFields(tt_address)." ORDER BY NAME";
				break;
                	        case "2":
					$query = "SELECT name,uid,zip FROM tt_address WHERE pid IN (".$pidList.")"." ".$this->cObj->enableFields(tt_address)." AND zip='".$zip."' ORDER BY NAME";
				break;
			}
		}
		$res = mysql(TYPO3_db,$query);

		$content = "
		<script language=\"JavaScript\" type=\"text/JavaScript\">
                <!--
                function MM_jumpMenu(targ,selObj,restore){
	                eval(targ+\".location='\"+selObj.options[selObj.selectedIndex].value+\"'\");
        	        if (restore) selObj.selectedIndex=0;
                }
                //-->
                </script>";

		$content .= '<select name="menu2" size=1 onchange="MM_jumpMenu(\'self\',this,0)" class="tx_spdirectory-pi1-small">';
		while($row = mysql_fetch_assoc($res)) {
			$content .= '<option value="'.$this->makeLink("",detail,"",$row[uid],$cache=1,$pointer=0).'"';
			$content .= ($id == $row[uid]) ? ' selected="selected" style="color: '.$this->conf[active].';">' : '>';
			$content .= htmlentities($row[name]).'</option>';
		}
		$content .= '</select>';

	return $content;
	}

	/**
	 * Generates a search Box
	 * Code adapted for xhml validity by Juergen Unfried 21.12.2005
	 */
	function makeSearchbox($search)	{

		$code = '<form method="post" action="'.$this->makeLink("",liste,search,"",0).'"><table cellspacing=0 cellpadding=0 border=0><tr>

					<td><input type="text" class="tx_spdirectory-pi1-small" name="tx_spdirectory_pi1[value]"';

		$code .= 	($this->piVars[modifier]==search) ? ' value="'.$search.'"' : "" ;

		$code .= ($this->piVars[modifier]==search) ? ' style="color: '.$this->conf[active].';font-size: 10px;"' : ' style="font-size: 10px;"';

		$code .= '	></td>
					<td><input type="submit" value="'.$this->pi_getLL("search").'" class="tx_spdirectory-pi1-small"></td>
					</tr></table></form>';

		return $code;
	}

}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/beko_spdirectoryxhmlbugfix/pi1/class.ux_tx_spdirectory.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/beko_spdirectoryxhmlbugfix/pi1/class.ux_tx_spdirectory.php']);
}

?>